<template>
  <Row class="stoker-stock-index">
    <i-col :span="24">
      <stock-search-block
          :fields="search.fields"
          :default-field="search.column"
          @on-search="searchAction">
        <template slot="btn-block">
          <RadioGroup v-model="type">
            <Radio label="0" size="large">view stock information</Radio>
            <Radio label="1" size="large">compare stock</Radio>
          </RadioGroup>
          <template v-if="toCompareStock && companiesToCompare.length > 0">
            <div class="redirect-to-compare-btn div-btn" @click="redirectStockCompareAction">
              <Icon type="md-send"></Icon>
            </div>
          </template>
        </template>

        <template>
          <div class="companies-list-block">
            <stock-company-card v-for="(company, index) in companiesToShow" :key="`${timestamp}-${index}`"
                                :company="company" @on-click="companyClickToCompareAction(company)">
              <div v-if="toSingleInfo" class="view-btn div-btn company-card-btn" @click.stop="redirectStockInfoAction(company.stockCode)">
                <Icon type="md-arrow-forward"></Icon>
              </div>
              <div v-if="isToCompare(company)" class="is-selected-btn div-btn company-card-btn">
                <Icon type="md-checkmark"></Icon>
              </div>
            </stock-company-card>
          </div>
        </template>
      </stock-search-block>
    </i-col>
  </Row>
</template>

<script>
import StockSearchBlock from "../../../components/StockSearchBlock";
import StockCompanyCard from "../../../components/StockCompanyCard";
import { validators as api } from '../../../configs/request-validator/company';

const actions = {
  searchAction({searchColumn, searchValue}) {
    this.search.column = searchColumn;
    this.search.value = searchValue;
  },
  companyClickToCompareAction(company) {
    if (this.toCompareStock) {
      const stockCode = company['stockCode'];
      const indexOfCompany = this.companiesToCompare.indexOf(stockCode);
      const isExist = indexOfCompany > -1;
      if (isExist) {
        this.companiesToCompare.splice(indexOfCompany, 1);
      } else {
        this.companiesToCompare.push(stockCode);
      }
    }
  },
  redirectStockCompareAction() {
    const query = { code: this.companiesToCompare.join('-') };
    this.$redirectTo('investor-stock-compare', undefined, query);
  },
  redirectStockInfoAction(stockCode) {
    const params = { code: stockCode };
    this.$redirectTo('investor-stock-code', params);
  }
};

export default {
  name: 'index',
  components: {StockCompanyCard, StockSearchBlock},
  data() {
    return {
      type: '0',
      companies: undefined,
      companiesToCompare: [],
      search: {
        column: 'stockCode',
        value: undefined,
        fields: [
          { value: 'id', label: 'ID' },
          { value: 'stockCode', label: 'Code' },
          { value: 'name', label: 'Name' },
        ]
      },
      companiesToShow: [],
      timestamp: new Date().getTime(),
    };
  },
  computed: {
    toSingleInfo() {
      return this.type === '0';
    },
    toCompareStock() {
      return this.type === '1';
    },
    amountOfCompaniesToShow() {
      if (Array.isArray(this.companiesToShow)) {
        return this.companiesToShow.length;
      } else {
        return Object.keys(this.companiesToShow).length;
      }
    }
  },
  watch: {
    ['search.column']() {
      this.setCompaniesToShow();
    },
    ['search.value']() {
      this.setCompaniesToShow();
    },
  },
  methods: {
    ...actions,
    isToCompare(company) {
      const { stockCode } = company;
      return this.toCompareStock && this.companiesToCompare.includes(stockCode);
    },
    setCompaniesToShow() {
      this.companiesToShow = [];
      const toFilter = this.search.column && this.search.value;
      const getAll = !this.search.value;
      if (toFilter) {
        Object.keys(this.companies).forEach(key => {
          const company = this.companies[key];
          const matchFilter = company[this.search.column].toString().includes(this.search.value);
          if (matchFilter) {
            this.companiesToShow.push(company);
          }
        });
      } else if (getAll) {
        this.companiesToShow = this.companies;
      }
      this.forceRender();
    },
    forceRender() {
      this.timestamp = new Date().getTime();
    },
  },
  mounted() {
    this.$displayBodyBlock(false);
    this.setCompaniesToShow();
  },
  async asyncData({app, store}) {
    let companies = undefined;
    const hasCompanies = store.getters['company/hasCompanies'];

    if (hasCompanies) {
      companies = store.getters['company/companies'];
    } else {
      // requests
      const companyRequestData = {};

      // invoke api
      try {
        const allResponse = await Promise.all([
          app.$api(api.GetAllCompanyRequest, companyRequestData, undefined, false),
        ]);

        // set vue value
        companies = allResponse[0]['data'];

        // store in vuex
        store.dispatch('company/setCompanies', companies);
      } catch (error) {
        app.$apiErrorHandler(error);
      }
    }

    return { companies };
  },
}
</script>

<style lang="scss" scoped>
  @import '../../../assets/css/mixin';

  .stoker-stock-index {
    height: 100%;
    .redirect-to-compare-btn {
      @include circle-div-btn(32);
    }
    .companies-list-block {
      height: calc(100vh - 185px);
      overflow-y: auto;
      .view-btn {
        @include circle-div-btn(32);
      }
      .is-selected-btn {
        @include circle-div-btn(32);
      }
    }
  }
</style>
